Index: /palm/trunk/SOURCE/data_output_module.f90
===================================================================
--- /palm/trunk/SOURCE/data_output_module.f90	(revision 4105)
+++ /palm/trunk/SOURCE/data_output_module.f90	(revision 4106)
@@ -3210,4 +3162,11 @@
       END SELECT
 
+      IF ( return_value == 0  .AND.  output_return_value /= 0 )  THEN
+         return_value = 1
+         CALL internal_message( 'error', routine_name //                              &
+                                ': error while writing variable "' // TRIM( name ) // &
+                                '" in file "' // TRIM( filename ) // '"' )
+      ENDIF
+
    ENDIF
 
@@ -3248,4 +3207,15 @@
    DO  f = 1, nf
       IF ( TRIM( filename ) == TRIM( files(f)%name ) )  THEN
+         
+         IF ( .NOT. files(f)%is_init )  THEN
+            return_value = 1
+            CALL internal_message( 'error', routine_name //                    &
+                                   ': file "' // TRIM( filename ) //           &
+                                   '" is not initialized. ' //                 &
+                                   'Writing variable "' // TRIM( var_name ) // &
+                                   '" to file is impossible.' )
+            EXIT
+         ENDIF
+         
          file_id     = files(f)%id
          file_format = files(f)%format
@@ -3421,5 +3391,6 @@
 
    INTEGER(iwp) ::  return_value           !< return value
-   INTEGER(iwp) ::  return_value_internal  !< return value from called routines
+   INTEGER(iwp) ::  return_value_internal  !< error code after closing a single file
+   INTEGER(iwp) ::  output_return_value    !< return value from called routines
    INTEGER(iwp) ::  f                      !< loop index
 
@@ -3429,25 +3400,35 @@
    DO  f = 1, nf
 
-      return_value_internal = 0
-
-      SELECT CASE ( TRIM( files(f)%format ) )
-
-         CASE ( 'binary' )
-            CALL binary_finalize( files(f)%id, return_value_internal )
-
-         CASE ( 'netcdf4-serial' )
-            CALL netcdf4_serial_finalize( files(f)%id, return_value_internal )
-
-         CASE ( 'netcdf4-parallel' )
-            CALL netcdf4_parallel_finalize( files(f)%id, return_value_internal )
-
-         CASE DEFAULT
-            return_value_internal = 1
-            CALL internal_message( 'error', routine_name // &
-                                   ': unsupported file format "' // TRIM( files(f)%format ) )
-
-      END SELECT
-
-      IF ( return_value_internal /= 0 )  return_value = return_value_internal
+      IF ( files(f)%is_init )  THEN
+
+         output_return_value = 0
+         return_value_internal = 0
+
+         SELECT CASE ( TRIM( files(f)%format ) )
+
+            CASE ( 'binary' )
+               CALL binary_finalize( files(f)%id, output_return_value )
+
+            CASE ( 'netcdf4-parallel', 'netcdf4-serial' )
+               CALL netcdf4_finalize( files(f)%id, output_return_value )
+
+            CASE DEFAULT
+               return_value_internal = 1
+
+         END SELECT
+
+         IF ( output_return_value /= 0 )  THEN
+            return_value = output_return_value
+            CALL internal_message( 'error', routine_name //             &
+                                   ': error while finalizing file "' // &
+                                   TRIM( files(f)%name ) // '"' )
+         ELSEIF ( return_value_internal /= 0 )  THEN
+            return_value = return_value_internal
+            CALL internal_message( 'error', routine_name //         &
+                                   ': unsupported file format "' // &
+                                   TRIM( files(f)%format ) // '"' )
+         ENDIF
+
+      ENDIF
 
    ENDDO
@@ -3488,15 +3469,12 @@
 
    CHARACTER(LEN=800), INTENT(OUT) ::  error_message         !< return error message to main program
-   CHARACTER(LEN=800)              ::  module_error_message  !< error message created by other module
-
-
-   CALL binary_get_error_message( module_error_message )
-   internal_error_message = TRIM( internal_error_message ) // module_error_message
-
-   CALL netcdf4_serial_get_error_message( module_error_message )
-   internal_error_message = TRIM( internal_error_message ) // module_error_message
-
-   CALL netcdf4_parallel_get_error_message( module_error_message )
-   internal_error_message = TRIM( internal_error_message ) // module_error_message
+   CHARACTER(LEN=800)              ::  output_error_message  !< error message created by other module
+
+
+   CALL binary_get_error_message( output_error_message )
+   internal_error_message = TRIM( internal_error_message ) // output_error_message
+
+   CALL netcdf4_get_error_message( output_error_message )
+   internal_error_message = TRIM( internal_error_message ) // output_error_message
 
    error_message = internal_error_message
